
; ---------------------------------------------------------------------------
; TestBed.asm
; ---------------------------------------------------------------------
; Author: frktons @ MASM32 forum
; Date: 14/nov/2010. 
;---------------------------------------------------------------------- 
; Enjoy - Frank
;----------------------------------------------------------------------------

include \masm32\include\masm32rt.inc

.686
.mmx
.xmm

include \masm32\macros\timers.asm
			
; get them from the 
; [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

LOOP_COUNT	= 100000 ; Number of iterations to perform

ustrv$ MACRO DDvalue1, DDvalue2   ;; unsigned integer to string
     invoke crt__ultoa,DDvalue1,DDvalue2,10
     EXITM <offset DDvalue2>
ENDM

include ProgData.inc


.code

start: 

; ---------------------------------------------------------------------------
; The Main Proc shows the program flow.
; ---------------------------------------------------------------------------

Main PROC

    mov RowInitialFile, One    
    mov RowFinalFile,   MaxRows    
    mov ColInitialFile, One   
    mov ColFinalFile,   MaxCols  

;----------------------------------------------------------------------------------------------------
; Initialize structure for calling GetNumberFormat
;----------------------------------------------------------------------------------------------------

mov NumFmt.NumDigits, 0               ; 0 for No decimal digits
mov NumFmt.LeadingZero, 0             ; 0 = No leading zeroes
mov NumFmt.Grouping, 3                ; Groups of three numbers
mov NumFmt.lpDecimalSep,  offset Sep  ; Pointer to NULL terminated string with the decimal separator 
mov NumFmt.lpThousandSep, offset Tsep ; Pointer to NULL terminated string with the thousand separator
mov NumFmt.NegativeOrder, 0           ; Negative number mode OFF

;----------------------------------------------------------------------------------------------------

    mov    DisplayFlag, NO
    
    CALL   ConsoleSize 

    CALL   GetConsole

    CALL   InitProc

    mov    PtrTextString, offset  TextString

    mov    PtrTextString, add$(PtrTextString, "TESTHELP.POP") 

    INVOKE ReadChosenFile, DWORD PTR PtrTextString, ADDR HelpBuffer

    INVOKE AlexConvertArea, ADDR HelpScreen, ADDR HelpBuffer, NumCycles

    mov    eax, PtrTextString

    xor    ebx, ebx
    
    mov    [eax], ebx

    mov    PtrTextString, add$(PtrTextString, "TESTINFO.POP") 

    INVOKE ReadChosenFile, DWORD PTR PtrTextString, ADDR InfoBuffer

    INVOKE AlexConvertArea, ADDR InfoScreen, ADDR InfoBuffer, NumCycles

    INVOKE AlexConvertArea, ADDR ConsoleScreen16, ADDR FileBuffer, NumCycles

    INVOKE DisplayFmt,   offset ConsoleScreen16

    INVOKE SaveArea, offset TestAreaBuffer, TestAreaRowInit, TestAreaColInit, 
                     TestAreaRowEnd, TestAreaColEnd
                      
    
    mov    ActualColor,  Zero
    
    INVOKE GetWindowsOS, ADDR szOS
    
    INVOKE lstrcat, ADDR szOS, CTEXT(13,10); Eliminate duplicate spaces

    INVOKE SetColorTo, BrightYellow, DarkBlue

    mov    Lenght, len(ADDR szOS)
   
    INVOKE DisplayAt, 7, 1, ADDR szOS, DWORD PTR Lenght

; ###########################################################################
; # This code is addeded by Alex 
; ###########################################################################
      
    invoke AxCPUid, offset CpuBuffer
    
    ; -----------------------------------------------------------------------
    ; NOTE: After a call to ^^^ this proc, the EAX is constructed, read
    ; comments above proc
    ; -----------------------------------------------------------------------
        
    movzx eax,ax	; maximal instruction sets, supported by CPU
 

    ; -------------------------------------------------------------------------------
    ; for example, if test include code, which is required SSSE3, then need to check
    ; an AX (or EBX in this sample) for 5. If number is smaller than 5, then SSSE3 
    ; is not supported and needed to manage that thing.
    ; -------------------------------------------------------------------------------
    
; ###########################################################################
;  Code replaced by Alex - he likes it popped and pushed :-) / I don't. ;-)
; ###########################################################################

    lea    esi, CpuBuffer

    mov    pbuf, esi

    invoke szMonoSpace, esi                ; format it with single space

    mov    Lenght, len(ADDR CpuBuffer)

TestDisplay:


    INVOKE SetColorTo, BrightWhite, DarkBlue

    INVOKE DisplayAt, ColCpuDesc, RowCpuDesc1, ADDR CpuBuffer, DWORD PTR Lenght   


; ###########################################################################


    INVOKE SetColorTo, BrightYellow, DarkBlue

    IF TestAlgo1 

       include MAlgo1.inc

    ENDIF

    IF TestAlgo2 

       include MAlgo2.inc

    ENDIF

    IF TestAlgo3 

       include MAlgo3.inc

    ENDIF

    IF TestAlgo4 

       include MAlgo4.inc

    ENDIF

    IF TestAlgo5 

       include MAlgo5.inc

    ENDIF

    IF TestAlgo6 

       include MAlgo6.inc

    ENDIF

    IF TestAlgo7 

       include MAlgo7.inc

    ENDIF

    IF TestAlgo8 

       include MAlgo8.inc

    ENDIF

    IF TestAlgo9 

       include MAlgo9.inc

    ENDIF

    IF TestAlgo10 

       include MAlgo10.inc

    ENDIF

    IF TestAlgo11 

       include MAlgo11.inc

    ENDIF

    IF TestAlgo12 

       include MAlgo12.inc

    ENDIF

    IF TestAlgo13 

       include MAlgo13.inc

    ENDIF

    IF TestAlgo14 

       include MAlgo14.inc

    ENDIF

    IF TestAlgo15 

       include MAlgo15.inc

    ENDIF

    IF TestAlgo16 

       include MAlgo16.inc

    ENDIF



; ---------------------------------------------------------------------------
; jump here to terminate the  sequence of Algo tests.
; If 16 Algos are tested the program flow will arrive here.
; ---------------------------------------------------------------------------

EndOfTests:

    mov    ConfirmExit, NO

    INVOKE SaveScreen, offset SavedScreen

    mov RunAgain, NO

      
    CALL   AnyKey

    .IF  ( ConfirmExit == YES )

        jmp Finish

    .ENDIF

    .IF  ( RunAgain == YES )

        jmp StartAlgo1

    .ENDIF


Finish: 


    CALL   ShowTheCursor

    INVOKE SetColorTo, BrightWhite, DarkBlack

    CALL   ClearScreen

    exit

Main ENDP


include ProgPROC.inc

;----------------------------------------------------------------------------
; End of program
;----------------------------------------------------------------------------

end start